/************************************************************************************
*                                 JavaScript project:                               *
*                                    Time Keeper v3                                 *
*                                                                                   *
*                                 20©08 f.e.d studios                               *
*                             http://www.fed-studios.com                            *
************************************************************************************/

function init(){
	System.Gadget.settingsUI = '../html/tk_v3_settings.html';
	System.Gadget.onSettingsClosed = settingsClosed;
	gSettingsObj = new gadgetSettingsObject();
	updateSettings();
	themesObj = new themes();
	themesObj.update();
	setTheme();
	
	tdObj = new timeDateObj();
	updateTime();
	timeTimer = setInterval(updateTime, 1000);
	
	if(selectedCalendar == -1){
		showNoCalendarMsg();
	}else{
		hideNoCalendarMsg();
		updateAppointments();
		appUpdateTimeout = setTimeout("startUpdateAppsTimer()", (appUpdateDelay * 1000));
	}
	saveTimer = setInterval(writeSettings, 60000);
}

function exit(){
	writeSettings();
}

function writeSettings(){
	gSettingsObj.activeCalendar = selectedCalendar;
	gSettingsObj.timeFormat = timeDisplayFormat;
	gSettingsObj.theme = selectedTheme;
	gSettingsObj.soundAlert = soundAlert;
	gSettingsObj.saveSettings();
}

function updateSettings(){	
	gSettingsObj.loadSettings();
	selectedCalendar = gSettingsObj.activeCalendar;
	timeDisplayFormat = gSettingsObj.timeFormat;
	selectedTheme = gSettingsObj.theme;
	soundAlert = gSettingsObj.soundAlert;
}

function settingsClosed(event){
	if (event.closeAction == event.Action.commit){
    	clearInterval(appTimer);
		updateSettings();
		setTheme();
		if(selectedCalendar == -1){
			showNoCalendarMsg();
		}else{
			hideNoCalendarMsg();
			updateAppointments();
			appUpdateTimeout = setTimeout("startUpdateAppsTimer()", (appUpdateDelay * 1000));			
		}
    }	
	self.focus();
}

function showNoCalendarMsg(){
	document.getElementById('app1').style.visibility = 'hidden';
	document.getElementById('app2').style.visibility = 'hidden';
	document.getElementById('app3').style.visibility = 'hidden';
	document.getElementById('app4').style.visibility = 'hidden';
	document.getElementById('noCal').style.visibility = 'visible';
}

function hideNoCalendarMsg(){
	document.getElementById('noCal').style.visibility = 'hidden';
}

function setTheme(){
	document.body.style.backgroundImage = themesObj.list[selectedTheme].image;
}

function execWC(){
	var execPath = System.Shell.knownFolderPath('ProgramFiles') + '\\Windows Calendar\\WinCal.exe';
	System.Shell.execute(execPath);
}

function updateTime(){
	tdObj.update();
	
	hours = tdObj.tdTime.hour;
    minutes = tdObj.tdTime.minutes;
    seconds = tdObj.tdTime.seconds;
	
	appUpdateDelay = 60 - seconds;
        
    var rotationHours = hours;

    if(hours > 12){
        rotationHours = hours - 12;
    }
	h.Rotation = (rotationHours * 30) + (minutes / 2);
    m.Rotation = (minutes * 6) + (seconds / 10);
	s.Rotation = (seconds * 6);
	
	var currentHours = hours;
    var currentMinutes = minutes;
    var currentSeconds = seconds;
	
	currentHours = (currentHours < 10 ? "0" : "") + currentHours;
	currentMinutes = (currentMinutes < 10 ? "0" : "") + currentMinutes;
	currentSeconds = (currentSeconds < 10 ? ":0" : ":") + currentSeconds;
	if(timeDisplayFormat == 12){
		var ampm;
		if(hours >= 12){
			ampm = ' PM';
		}else{
			ampm = ' AM';
		}
		if(rotationHours == 12){
			rotationHours = 0;
		}
		digitalClock.innerText = rotationHours + ":" + currentMinutes + ampm;
	}else{
		digitalClock.innerText = currentHours + ":" + currentMinutes + currentSeconds;
	}
	
	dateDisplay.innerText = tdObj.tdDate.date.toString() + '.';
	monthDisplay.innerText = tdObj.tdDate.localMonthArray[tdObj.tdDate.month];
	yearDisplay.innerText = tdObj.tdDate.year.toString();
	dayDisplay.innerText = tdObj.tdDate.localDayArray[tdObj.tdDate.day] + ' ' + tdObj.tdDate.date.toString() + '. ' + tdObj.tdDate.localFullMonthArray[tdObj.tdDate.month];
}

function startUpdateAppsTimer(){
	appTimer = setInterval(updateAppointments, 60000);
}

function updateAppointments(){
	appsObj = new appointments();
	
	wcSet = new wcSettings();
	wcSet.populateCalendars();
		
	calendarFile = wcSet.folder + '\\' + wcSet.calendars[selectedCalendar] + '.ics';
	appsObj.filename = calendarFile;
	
	if(appsObj.update()){
		var upcoming = new upcomingAppointmentsList();
		upcoming.update(appsObj.list, tdObj);
		document.getElementById('app1').style.visibility = 'visible';
		document.getElementById('app2').style.visibility = 'visible';
		document.getElementById('app3').style.visibility = 'visible';
		document.getElementById('app4').style.visibility = 'visible';
		var showAppCount;
		if(upcoming.list.length < 4){
			showAppCount = (upcoming.list.length - 1);
			for(var s=(showAppCount + 1);s<=3; s++){
				document.getElementById('app' + (s + 1)).style.visibility = 'hidden';
			}
		}else{
			showAppCount = 3;
		}	
		var testChar = new String('W');
		var charWidth = testChar.textWidth();
		for(var sac=0; sac<=showAppCount;sac++){
			var itext = upcoming.list[sac];
			//itext = itext.replace(//, '');
			document.getElementById('app' + (sac + 1) + '_info').title = itext;
			if(itext.textWidth() > 120){
				var charCount = Math.floor(100/charWidth) + 10;
				var itShort = itext.substr(0, charCount) + '...';
				document.getElementById('app' + (sac + 1) + '_info').innerHTML = itShort;
			}else{
				document.getElementById('app' + (sac + 1) + '_info').innerHTML = itext;
			}		
		}
	}
}