/************************************************************************************
*                                 JavaScript project:                               *
*                                    Time Keeper v3                                 *
*                                       Settings                                    *
*                                                                                   *
*                                 2008 f.e.d studios                               *
*                             http://www.fed-studios.com                            *
************************************************************************************/


var gso;
var selectedCalendar;
var soundAlert;
var bgThemes;
var selectedTheme;
var timeDisplayFormat = 24;
var wcS;

function initSettings(){
	System.Gadget.onSettingsClosing = settingsClosing;
	gso = new gadgetSettingsObject();
	updateGSO();
	wcS = new wcSettings();
	wcS.populateCalendars();
	for(var j=0; j<wcS.calendars.length; j++){
		var newElem = document.createElement("option");
		newElem.text = wcS.calendars[j];
		newElem.value = j;
		document.getElementById('calendars').options.add(newElem);
	}
	
	if(selectedCalendar != -1){
		document.getElementById('calendars').selectedIndex = selectedCalendar;
	}
	if(soundAlert == 1){
		document.getElementById('soundAlert').checked = true;
	}
	if(timeDisplayFormat == 12){
		document.getElementById('12hrs').checked = true;
	}else{
		document.getElementById('24hrs').checked = true;
	}
	bgThemes = new themes();
	bgThemes.update();
	document.getElementById('themePreview').style.backgroundImage = bgThemes.list[selectedTheme].image;
	document.getElementById('themePreview').style.backgroundRepeat = 'no-repeat';
	document.getElementById('themePreview').style.backgroundPosition = 'center center';
	document.getElementById('themeName').innerHTML = bgThemes.list[selectedTheme].name;
}

function stepBack(){
	if(selectedTheme > 0){
		selectedTheme = selectedTheme - 1;
	}else{
		selectedTheme = bgThemes.list.length - 1;
	}
	document.getElementById('themePreview').style.backgroundImage = bgThemes.list[selectedTheme].image;
	document.getElementById('themeName').innerHTML = bgThemes.list[selectedTheme].name;
}

function stepForward(){
	if(selectedTheme < bgThemes.list.length - 1){
		selectedTheme = selectedTheme + 1;
	}else{
		selectedTheme = 0;
	}
	document.getElementById('themePreview').style.backgroundImage = bgThemes.list[selectedTheme].image;
	document.getElementById('themeName').innerHTML = bgThemes.list[selectedTheme].name;
}

function settingsClosing(event){
	if (event.closeAction == event.Action.commit){
    	if(document.getElementById('soundAlert').checked){
			soundAlert = 1;
		}else{
			soundAlert = 0;
		}
		if(document.getElementById('12hrs').checked){
			timeDisplayFormat = 12;
		}else{
			timeDisplayFormat = 24;
		}
		writeGSO();
    }
}

function writeGSO(){
	gso.activeCalendar = document.getElementById('calendars').selectedIndex;
	gso.timeFormat = timeDisplayFormat;
	gso.theme = selectedTheme;
	gso.soundAlert = soundAlert;
	gso.saveSettings();
}

function updateGSO(){	
	gso.loadSettings();
	selectedCalendar = gso.activeCalendar;
	timeDisplayFormat = gso.timeFormat;
	selectedTheme = gso.theme;
	soundAlert = gso.soundAlert;
}